/*********************************************************************
*                                                                    *
* CODIGO PARA EL ROBOT PINZITAS (BUSCA, COGE Y LLEVA LOS CANUTOS)    *
*                                                                    *
* REALIZADO POR : DIEGO CHAPARRO Y SERGIO ANDRS GONZLEZ (GRUPO 8)  *
*                                                                    *
* REALIZADO PARA : UNIVERSIDA REY JUAN CARLOS (ROBOTICA)             *
*                                                                    *
**********************************************************************


#include <conio.h>
#include <unistd.h>
#include <sys/tm.h>
#include <dsensor.h>
#include <dmotor.h>

#define LIGHTSENS       SENSOR_2
#define DARK_THRESH     0x40
#define BRIGHT_THRESH   0x48

#define NORMAL_SPEED (2*MAX_SPEED/3)
#define TURN_SPEED   (MAX_SPEED)
int choque;
int avance;
int cogido;

/*static wakeup_t dark_found(wakeup_t data) {
  return LIGHT(LIGHTSENS)<(unsigned short)data;
}*/


static wakeup_t bright_found(wakeup_t data) {
  return LIGHT(LIGHTSENS)>(unsigned short)data;
}

wakeup_t sensor_press_wakeup(wakeup_t data) {
        lcd_refresh();
	return SENSOR_1<0xf000 || SENSOR_3<0xf000;
}

// TAREA AVANZAR. AVANZA PASADO UN TIEMPO SI NO SE HA ENCONTRADO NINGUN CANUTO

int tarea_avanzar (int argc, char *argv[]) {
        int i;
        while (1) {
                i = 1;
                while ((i < 275) && avance){
                      //cputw(i);
                      i = i++;
                      msleep(1);
                }

                if (avance){
                    motor_a_dir(fwd);
                    motor_b_dir(fwd);
                    sleep(2);
                    motor_a_dir(rev);
                }
        }
        return(0);
}


        

// TAREA CHOQUES. PARA ESQUIVAR LOS OBSTACULOS

int tarea_choques (int argc, char *argv[]) {
        int dir, tiempo;

        dir = 0;
        tiempo = 800;
        while(1){

                wait_event(&sensor_press_wakeup,0);
                choque = 1;
                avance = 0;

                if (SENSOR_1<0xf000) {
			if (SENSOR_3>=0xf000) {
                        // SI SE HA PRESIONADO EL IZQUIERDO RETROCEDE Y GIRA A LA DERECHA
				motor_a_dir(rev);
                                motor_b_dir(rev);
				msleep (tiempo*1.5);
				motor_a_dir(fwd);
				cputs ("derecha");
				msleep (tiempo*1);
			} else {

                        // SI SE HAN PRESIONADO LOS DOS RETROCEDE Y GIRA MAS
				motor_a_dir(rev);
                                motor_b_dir(rev);
				msleep (tiempo*4);
				if (dir==0) {
                                        motor_b_dir(fwd);
					dir=1;
				}else {
					motor_a_dir(fwd);
					dir=0;
				}
				cputs("giro");
				msleep (tiempo*2);
			}
                } else  {

                        // SI SE HA PRESIONADO EL DERECHO RETROCEDE Y GIRA A LA IZQUIERDA
			if (SENSOR_3<0xf000) {
				motor_a_dir(rev);
                                motor_b_dir(rev);
				msleep (tiempo*1.5);
                                motor_b_dir(fwd);
				cputs ("izquier");
				msleep (tiempo*1);
                        }
                }
                motor_a_dir(fwd);
                motor_b_dir(fwd);
                msleep(1000);

                // VUELVE A DAR VUELTAS BUSCANDO LOS CANUTOS
                motor_a_dir(rev);
                motor_a_speed(MAX_SPEED/4);
                motor_b_speed(MAX_SPEED/4);
                avance = 1;
                sleep(0.5);
                
        }

}  // Tarea_choques //





int main(int argc, char *argv[]) {
    int total, num, i;
    int t1, t2;
    t1=execi(&tarea_choques, argc, argv, 1, DEFAULT_STACK_SIZE);
    t2=execi(&tarea_avanzar, argc, argv, 1, DEFAULT_STACK_SIZE);
    tm_start();
    choque = 0;
    avance = 0;
    ds_active(&LIGHTSENS);
  
    motor_a_speed(MAX_SPEED/4);
    motor_b_speed(MAX_SPEED/4);
    motor_b_dir(fwd);
    motor_a_dir(rev);
    total=0;
    sleep (1);

// CALIBRAR EL SENSOR DE LUZ //

    for (i=1; i<20; i++) {
        num = (int)(LIGHT(LIGHTSENS));
        cputw (num);
        total=total+num;
        msleep (200);
    }
    total=total/20;
    cputw ((total));
    sleep (3);
    avance = 1;

     
    cogido = 0;
    while (1) {

        // GIRAMOS BUSCANDO LOS CANUTOS
        avance = 1;
        motor_b_dir(fwd);
        motor_a_dir(rev);
        motor_a_speed(MAX_SPEED/4);
        motor_b_speed(MAX_SPEED/4);


        cputw(LIGHT(LIGHTSENS));

        // SI ENCUENTRA MAS LUZ DE LA MEDIA + 35 SUPONEMOS QUE ES UN CANUTO.
        wait_event (bright_found, total+35);
	cputw((int)(LIGHT(LIGHTSENS)));
        avance = 0;

        // AVANZAMOS PARA ACERCARNOS AL CANUTO
        motor_a_dir(fwd);
        motor_b_dir(fwd);
        msleep(500);
                                  

        // ENCONTRADO EL CANUTO //

        if (!choque) {
                motor_a_dir(brake);
                motor_b_dir(brake);

                // BAJAR PINZA

                motor_c_dir(fwd);
                motor_c_speed(MAX_SPEED);
                msleep(1070);

                // SUBIR PINZA Y COGE EL CANUTO
                motor_c_dir(rev);
                msleep (1250);
                cogido = 1;

                motor_c_dir(brake);
        } else
                choque = 0;

        // UNA VEZ COGIDO EL CANUTO LO LLEVAMOS A UN LUGAR CON LUZ

        if (cogido) {

                // BUSCAMOS LA LUZ
                motor_a_dir(rev);
                motor_b_dir(fwd);

                cputw(LIGHT(LIGHTSENS));

                // SI VEMOS MAS LUZ QUE LA MEDIA + 30 AVANZAMOS HACIA ELLA
                wait_event (bright_found, total+30);

                motor_a_dir(fwd);

                // CUANDO LLEGAMOS AL TOPE SOLTAMOS EL CANUTO
                wait_event(&sensor_press_wakeup,0);

                // BAJAR PINZA Y LO SUELTA
                motor_c_dir(fwd);
                motor_c_speed(MAX_SPEED);
                msleep(1070);

                // SUBIR PINZA
                motor_c_dir(rev);
                msleep (1400);
                motor_c_dir(brake);

                // RETROCEDE PARA LUEGO SEGUIR BUSCANDO CANUTOS                                           
                motor_a_dir(rev);
                motor_b_dir(rev);
                msleep (2000);

                cogido = 0;

        } 
    }
}



