/*************************************************************************************
*                          Realizado por:                                            *
*	            Sergio A. Gonzlez Galindo                                       *
*	              Diego Chaparro Gonzlez			4-5-2000             *
*************************************************************************************/
/* 
Programa que permite a un robot hacer una carrera de obstculos.
El robot tiene dos sensores de tacto. Cuando uno de ellos es presionado retrocede un
poco para atrs y gira hacia el lado contrario del sensor que toc. Y a los pocos 
segundos vuelve a girar hacia el otro lado para recuperar la trayectoria que llevaba.
Si tocan los dos sensores a la vez el robot retrocede ms hacia atrs y hace un giro 
ms grande para evitar quedarse atrapado en los rincones.
*/
#include <conio.h>
#include <unistd.h>

#include <dsensor.h>
#include <dmotor.h>
#include <sys/tm.h>
#include <dsound.h>

wakeup_t sensor_press_wakeup(wakeup_t data);
const int tiempo=100;
int direccion=0;
int cambio=0;
int dir=0;
int nveces=0;
static const note_t robots[] = {
 { PITCH_D4,  2 } , { PITCH_C4,  1 } , { PITCH_D4,  1 },
  { PITCH_F4,  1 } , { PITCH_D4,  1 } , { PITCH_D4,  2 },
  { PITCH_F4,  2 } , { PITCH_G4,  1 } , { PITCH_C5,  1 },
  { PITCH_A4,  2 } , { PITCH_D4,  2 } , { PITCH_END, 0 }

};


// TAREA PARA EJECUTAR SONIDOS
int tareasonido (int argc, char *argv[]) {
	while(1){
		dsound_play(robots);
		wait_event(dsound_finished, 0);
	}
}


// TAREA QUE SE OCUPA DE ACTUAR CUANDO SE PRESIONA ALGUNO DE LOS SENSORES
int tarea1 (int argc, char *argv[]) {
	//int nveces=0;
	cputs ("TAREA");	
	while (1) {
		wait_event(&sensor_press_wakeup,0);

		// SI SE HA PRESIONADO EL SENSOR 1
		if (SENSOR_1<0xf000) {
			// Y SOLO EL SENSOR 1
			if (SENSOR_3>=0xf000) {
				// RETROCEDE UN POCO Y GIRA A LA DERECHA
				motor_a_dir(rev);
				motor_c_dir(rev);
				msleep (tiempo*1.5);
				motor_a_dir(fwd);
				cputs ("derecha");
				msleep (tiempo*1);
				direccion++;
			} else {
				// SI SE HAN PRESIONADO LOS DOS
				// RETROCEDE Y GIRA ALTERNATIVAMENTE UNA VEZ
				// PARA CADA LADO
				motor_a_dir(rev);
				motor_c_dir(rev);
				msleep (tiempo*4);
				if (dir==0) {
					motor_c_dir(fwd);
					dir=1;
					direccion-=2;
				}else {
					motor_a_dir(fwd);
					dir=0;
					direccion+=2;
				}
				cputs("giro");
				msleep (tiempo*2);
			}
		} else
			// SI SE HA PRESIONADO EL SENSOR 3
			if (SENSOR_3<0xf000) {
				// RETROCEDE Y GIRA HACIA LA IZQUIERDA
				motor_a_dir(rev);
				motor_c_dir(rev);
				msleep (tiempo*1.5);
				motor_c_dir(fwd);
				cputs ("izquier");
				msleep (tiempo*1);
				direccion--;
			}
		// AVANZA HACIA DELANTE
		motor_a_dir(fwd);
		motor_c_dir(fwd);
		msleep(400);
		
		// SI DESPUS DE HABER CHOCADO UNA VEZ, VUELVE A CHOCAR, O HA CHOCADO
		// UNAS CUANTAS VECES SEGUIDAS, ENTONCES RETROCEDE MS DE LO NORMAL
		// PORQUE ESTAR ENCAJONADO EN UN RINCN
		if (!(SENSOR_3<0xf000 || SENSOR_1<0xf000) || nveces>3) {
			if (nveces>3) {
				if (direccion>0) 
					motor_a_speed(MAX_SPEED/3);
				 else
					motor_c_speed(MAX_SPEED/3);
				motor_a_dir(rev);
				motor_c_dir(rev);
				msleep(tiempo*2.5);
			}
			
			// SE CAMBIA LA VARIABLE PARA QUE SIGA EJECUTANDO EL PROGRAMA PRINC
			cambio=1;
			while (cambio==1) {
				msleep(1);
			}
			nveces=0;
		}
		else {
			nveces++;
			cputs ("dos vec");
		}
	}
}
	

int main(int argc, char *argv[]) {
	int t1, t2;
	int diraux=0;
   	
	// ARRANCAMOS LAS DOS TAREAS
	t1=execi(&tarea1, argc, argv, 1, DEFAULT_STACK_SIZE); 
	t2=execi(&tareasonido, argc, argv, 1, DEFAULT_STACK_SIZE);
	tm_start();
	    	

        motor_a_speed(MAX_SPEED*2/3);
        motor_c_speed(MAX_SPEED*2/3);

	motor_a_dir(fwd);
	motor_c_dir(fwd);
	while(1) {
		diraux=0;
		cputs ("PRIN");

		// SI HA GIRADO HACIA LA IZQUIERDA, DIRECCION SER MENOR DE 0,
		// POR LO TANTO HABRA QUE RECUPERAR LA DIRECCIN HACIA LA DERECHA
    		if (direccion<0) {
			if (direccion<-3) 
				direccion=-3;
			if (nveces>3){
				motor_a_dir(fwd);
				diraux++;	
			}else
				motor_c_dir(rev);
			msleep ((-1)*(direccion)*tiempo*2/3);
		} else
			// SI HA GIRADO HACIA LA DERECHA, DIRECCIN SER MAYOR DE 0,
			// Y HABR QUE RECUPERAR LA DIRECCIN HACIA LA IZQUIERDA
			if (direccion>0){
				if (direccion>3)
					direccion=3;
				if (nveces>3){
					motor_c_dir(fwd);
					diraux--;
				}
				else
					motor_a_dir(rev);
				msleep (direccion*tiempo*2/3);
			}
		
		// SIGUE AVANZANDO HACIA DELANTE
		direccion=diraux;
                motor_a_speed(MAX_SPEED*2/3);
                motor_c_speed(MAX_SPEED*2/3);
		motor_a_dir(fwd);
    		motor_c_dir(fwd);
	    		
		// EL PROGRAMA PRINCIPAL SE QUEDA EN EL BUCLE, Y SE EJECUTA LA TAREA
		cambio=0;
		while (cambio==0) {
			msleep(1);
		}	
		if (direccion!=0) 
			msleep(tiempo*4);
		else
			msleep(tiempo*8);

  	}
}

wakeup_t sensor_press_wakeup(wakeup_t data) {
        lcd_refresh();
	return SENSOR_1<0xf000 || SENSOR_3<0xf000;
}


