/*********************************************************************
*                                                                    *
* CODIGO PARA EL ROBOT ESCORPION (SIGUE LA PARED)                    *
*                                                                    *
* REALIZADO POR : DIEGO CHAPARRO Y SERGIO ANDRS GONZLEZ (GRUPO 8)  *
*                                                                    *
* REALIZADO PARA : UNIVERSIDA REY JUAN CARLOS (ROBOTICA)             *
*                                                                    *
**********************************************************************

#include <conio.h>
#include <unistd.h>

#include <dsensor.h>
#include <dmotor.h>
#include <sys/tm.h>
#include <dsound.h>

const int tiempo=40;
int chocado;

static const note_t robots[] = {
 { PITCH_D4,  2 } , { PITCH_C4,  1 } , { PITCH_D4,  1 },
  { PITCH_F4,  1 } , { PITCH_D4,  1 } , { PITCH_D4,  2 },
  { PITCH_F4,  2 } , { PITCH_G4,  1 } , { PITCH_C5,  1 },
  { PITCH_A4,  2 } , { PITCH_D4,  2 } , { PITCH_END, 0 }

};

wakeup_t sensor_press_wakeup(wakeup_t data) {
        lcd_refresh();
	return SENSOR_1<0xf000 || SENSOR_3<0xf000;
}


int tareasonido (int argc, char *argv[]) {
	while(1){
		dsound_play(robots);
		wait_event(dsound_finished, 0);
	}
}

// TAREA PARA CONTROLAR LOS CHOQUES
int tarea1 (int argc, char *argv[]) {
	//int nveces=0;
	cputs ("TAREA");	
	while (1) {
		wait_event(&sensor_press_wakeup,0);

                //chocado = 1;

		// SI SE CHOCA CON EL LADO IZQUIERDO
                if (SENSOR_1<0xf000) {
                     // UN POCO PARA ATRAS 
			
			chocado=2;
                        motor_a_dir(rev);
                        motor_c_dir(rev);
                        msleep (tiempo*4);

                     // UN POCO PARA LA IZQUIERDA Y SIGO DE FRENTE

                        motor_c_dir(fwd);
                        msleep (tiempo*3);
                        motor_a_dir(fwd);
			msleep (tiempo);
                        cputs ("izqui");
                } else {
			// SI SE CHOCA CON EL DERECHO
			// GIRA HACIA LA IZQUIERDA
                        chocado=1;
			motor_c_dir(fwd);
                        motor_a_dir(rev);
			msleep (tiempo*2/3);

                        motor_a_dir(fwd);
                        cputs ("izqui");
                }
                chocado = 0;
   
        }
}


int main (int argc, char *argv[]) {
        int t1, t2, nveces;

        // ARRANCAMOS LAS DOS TAREAS
	t1=execi(&tarea1, argc, argv, 1, DEFAULT_STACK_SIZE);
        t2=execi(&tareasonido, argc, argv, 1, DEFAULT_STACK_SIZE);        
        tm_start();
        nveces = 0;

        chocado = 0;

	// GIRAMOS A LA DERECHA AL EMPEZAR Y SEGUIMOS RECTO HASTA ENCONTRAR LA PARED
        motor_a_speed(MAX_SPEED*2/3);
        motor_c_speed(MAX_SPEED*2/3);
        motor_a_dir(fwd);
        motor_c_dir(rev);
        msleep(tiempo*3);
        motor_c_dir(fwd);
        while (!chocado)
                msleep (10); 
                
                
        while (1) {
		// VAMOS PARA ALANTE
                motor_a_speed(MAX_SPEED*2/3);       
                motor_c_speed(MAX_SPEED*2/3);

                motor_a_dir(fwd);
                motor_c_dir(fwd);

                msleep(tiempo*2);

		// SI NO SE HA CHOCADO, GIRAMOS A LA DERECHA BUSCANDO LA PARED
                if (!chocado)
                {
                        motor_c_dir(rev);
                        msleep(tiempo*1.5);
                        motor_c_dir(fwd);
                }

                // SI DESPUES DE GIRAR A LA DERECHA NO SE HA CHOCADO, INCREMENTAMOS
                // LA VARIABLE NVECES
                if (!chocado)
                    nveces++;
                else
                    nveces = 0;

                // SI NVECES SUPERA EL VALOR DE 20, LLEVA MUCHO TIEMPO SIN CHOCARSE
                // LUEGO BUSCAMOS LA PARED, AVANZANDO HACIA DELANTE
                if (nveces >= 20) {
                     motor_a_dir(fwd);
                     motor_c_dir(fwd);
                     msleep(tiempo*10);
                     nveces = 0;
                }

                // CUANDO HA CHOCADO EL PRINCIPAL ESPERA HASTA QUE LA TAREA HAGA
                // SU TRABAJO Y PONGA CHOCADO A 0

                while (chocado) {
                   msleep(tiempo/9);
                }
        }

}


                



